#include <stdio.h>
#include <string.h>

char key[] = "the quick brown fox jumps over the lazy dog";

bool Match(char line[], char dec[])
{
    for ( int i = 0; i < 128; i++ ) dec[i] = 0;
    dec[' '] = ' ';

    int len = strlen(key);
    if ( strlen(line) != len ) return false;

    for ( int i = 0; i < len; i++ ) {
        if ( dec[line[i]] == 0 ) dec[line[i]] = key[i];
            else if ( dec[line[i]] != key[i] ) return false;
    }
    return true;
}

bool Decypher(char lines[][100], int len)
{
    int i;
    char dec[128];

    for ( i = 0; i < len; i++ )
        if ( Match(lines[i], dec) ) break;
    if ( i == len ) return false;

    for ( i = 0; i < len; i++ ) {
        for ( int j = 0; lines[i][j] != 0; j++ )
            lines[i][j] = dec[lines[i][j]];
    }
    return true;
}

int main()
{
    int n;
    static char lines[100][100];

    scanf(" %d ", &n);

    for ( int i = 0; i < n; i++ ) {
        int len = 0;
        while ( true ) {
            gets(lines[len]);
            if ( strlen(lines[len]) == 0 ) break;
            len++;
        }
        if ( Decypher(lines, len) )
            for ( int j = 0; j < len; j++ ) printf("%s\n", lines[j]);
        else printf("No solution.\n");
        printf("\n");
    }

    return 0;
}

